App GeoFeature/it: Difference between revisions

From FreeCAD Documentation
(Updating to match new version of source page)
(Updating to match new version of source page)
Line 106: Line 106:
For example, the [[Arch_BuildingPart|Arch BuildingPart]] element of the [[Arch_Workbench|Arch Workbench]] is an {{incode|App::GeometryPython}} object with a custom icon.
For example, the [[Arch_BuildingPart|Arch BuildingPart]] element of the [[Arch_Workbench|Arch Workbench]] is an {{incode|App::GeometryPython}} object with a custom icon.


{{Document objects navi{{#translation:}}}}
<div class="mw-translate-fuzzy">
{{Userdocnavi/it}}
{{Userdocnavi{{#translation:}}}}
</div>

Revision as of 18:02, 19 February 2020

Introduzione

Un oggetto App GeoFeature, o formalmente un App::GeoFeature, è la classe base della maggior parte degli oggetti che visualizzano elementi geometrici nella vista 3D.

Diagramma semplificato delle relazioni tra gli oggetti principali del programma. La classe App::GeoFeature è essenzialmente la classe base di tutti gli oggetti nel software che mostrano una forma nella vista 3D.

Utilizzo

The App GeoFeature is an internal object, so it cannot be created from the graphical interface. It is generally not meant to be used directly, rather it can be sub-classed to get a bare-bones object that only has a basic DatiPlacement property to define its position in the 3D view.

Some of the most important derived objects are the following:

When creating this object in Python, instead of sub-classing App::GeoFeature, you should sub-class App::GeometryPython because the latter includes a default view provider, and Proxy attributes for the object itself, and its view provider. See Scripting.

Proprietà

An App GeoFeature (App::GeoFeature class) is derived from the basic App DocumentObject (App::DocumentObject class), therefore it shares all the latter's properties.

In addition to the properties described in App DocumentObject, the GeoFeature has the DatiPlacement property, which controls its position in the 3D view.

See Property for all property types that scripted objects can have.

These are the properties available in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.

Dati

Base

  • DatiPlacement (Placement): the position of the object in the 3D view. The placement is defined by a Base point (vector), and a Rotation (axis and angle). See Placement.
    • DatiAngle: the angle of rotation around the DatiAxis. By default, it is (zero degrees).
    • DatiAxis: the unit vector that defines the axis of rotation for the placement. Each component is a floating point value between 0 and 1. If any value is above 1, the vector is normalized so that the magnitude of the vector is 1. By default, it is the positive Z axis, (0, 0, 1).
    • DatiPosition: a vector with the 3D coordinates of the base point. By default, it is the origin (0, 0, 0).
  • DatiLabel (String): the user editable name of this object, it is an arbitrary UTF8 string.

Hidden properties Data

  • DatiExpression Engine (ExpressionEngine): a list of expressions. By default, it is empty [].
  • DatiLabel2 (String): a longer, user editable description of this object, it is an arbitrary UTF8 string. By default, it is an empty string "".
  • DatiProxy (PythonObject): a custom class associated with this object. This only exists for the Python version. See Scripting.
  • DatiVisibility (Bool): whether to display the object or not.

Vista

Base

  • VistaBounding Box (Bool): if it is true, the object will show the bounding box in the 3D view.
  • VistaDisplay Mode (Enumeration): it is empty by default.
  • VistaOn Top When Selected (Enumeration): Disabled (default), Enabled, Object, Element.
  • VistaSelectable (Bool): if it is true, the object can be picked with the pointer in the 3D view. Otherwise, the object cannot be selected until this option is set to true.
  • VistaSelection Style (Enumeration): Shape (default), BoundBox. If the option is Shape, the entire shape (vertices, edges, and faces) will be highlighted in the 3D view; if it is BoundBox only the bounding box will be highlighted.
  • VistaShape Color (Color): a tuple of three floating point RGB values (r,g,b) to define the color of the faces in the 3D view; by default it is (0.8, 0.8, 0.8), which is displayed as [204,204,204] on base 255, a light gray .
  • VistaShow In Tree (Bool): if it is true, the object appears in the tree view. Otherwise, it is set as invisible.
  • VistaTransparency (Percent): an integer from 0 to 100 that determines the level of transparency of the faces in the 3D view. A value of 100 indicates completely invisible faces; the faces are invisible but they can still be picked as long as VistaSelectable is true.
  • VistaVisibility (Bool): if it is true, the object appears in the 3D view; otherwise it is invisible. By default this property can be toggled on and off by pressing the Space bar in the keyboard.

Hidden properties View

  • VistaProxy (PythonObject): a custom view provider class associated with this object. This only exists for the Python version. See Scripting.
  • VistaShape Material (Material): an App Material associated with this object. By default it is empty.

Script

See also: FreeCAD Scripting Basics, and scripted objects.

See Part Feature for the general information on adding objects to the program

A GeoFeature is created with the addObject() method of the document. If you would like to create an object with a 2D or 3D topological shape, it may be better to create one of the sub-classes specialized for handling shapes, for example, Part Feature or Part Part2DObject.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("App::GeoFeature", "Name")
obj.Label = "Custom label"

This basic App::GeoFeature doesn't have a default view provider, so no icon will be displayed on the tree view, and no View properties will be available.

Therefore, for Python subclassing, you should create the App::GeometryPython object.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("App::GeometryPython", "Name")
obj.Label = "Custom label"

For example, the Arch BuildingPart element of the Arch Workbench is an App::GeometryPython object with a custom icon.